package com.iotechn.unimall.admin.api.sys;

import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.model.Page;
import com.iotechn.unimall.data.domain.CollectionPaymentDO;
import com.iotechn.unimall.data.dto.CollectionPaymentDTO;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Generate Code By Unimall
 */
@HttpOpenApi(group = "admin.collectionpayment", description = "unimall_collection_paymentService")
public interface CollectionPaymentService {

    @HttpMethod(description = "删除", permission = "collectionPayment:collectionpayment:delete", permissionParentName = "其他", permissionName = "CollectionPayment")
    public boolean delete(
            @NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "id") Long id) throws ServiceException;


    @HttpMethod(description = "查询", permission = "collectionPayment:collectionpayment:list", permissionParentName = "其他", permissionName = "CollectionPayment")
    public Page<CollectionPaymentDO> list(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") CollectionPaymentDTO selectDTO,
            @HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
            @HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit) throws ServiceException;

    @HttpMethod(description = "添加", permission = "collectionPayment:collectionpayment:create", permissionParentName = "其他", permissionName = "CollectionPayment")
    public CollectionPaymentDO create(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") CollectionPaymentDTO insertDTO) throws ServiceException;

    @HttpMethod(description = "编辑", permission = "collectionPayment:collectionpayment:edit", permissionParentName = "其他", permissionName = "CollectionPayment")
    public String edit(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") CollectionPaymentDTO editDTO) throws ServiceException;


    @HttpMethod(description = "查询统计", permission = "collectionPayment:collectionpayment:listReport", permissionParentName = "其他", permissionName = "CollectionPayment")
    public List<CollectionPaymentDTO> listReport(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") CollectionPaymentDTO selectDTO) throws ServiceException;


    @HttpMethod(description = "导出", permission = "collectionPayment:collectionpayment:export", permissionParentName = "其他", permissionName = "CollectionPayment")
    public String export(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") CollectionPaymentDTO collectionPaymentDTO,
            @HttpParam(name = "HttpServletResponse", type = HttpParamType.COMMON, description = "response") HttpServletResponse response) throws Exception;


    @HttpMethod(description = "添加", permission = "collectionPayment:collectionpayment:createAll", permissionParentName = "其他", permissionName = "CollectionPayment")
    public void createAll(
            @HttpParam(name = "CollectionPaymentDTO", type = HttpParamType.COMMON, description = "CollectionPaymentDTO") List<CollectionPaymentDTO> collectionPaymentDTOS) throws ServiceException;


}