package com.iotechn.unimall.admin.api.sys;

import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.model.Page;
import com.iotechn.unimall.data.domain.CustomerBillingDetailDO;
import com.iotechn.unimall.data.dto.CustomerBillingDetailDTO;

/**
 * Generate Code By Unimall
 */
@HttpOpenApi(group = "admin.customerbillingdetail", description = "unimall_customer_billing_detailService")
public interface customerBillingDetailService {

    @HttpMethod(description = "删除", permission = "customerBillingDetail:customerbillingdetail:delete", permissionParentName = "其他", permissionName = "customerBillingDetail")
    public boolean delete(
            @NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "id") Long id,
            @NotNull @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "管理员ID") Long adminId) throws ServiceException;


    @HttpMethod(description = "查询", permission = "customerBillingDetail:customerbillingdetail:list", permissionParentName = "其他", permissionName = "customerBillingDetail")
    public Page<CustomerBillingDetailDO> list(
            @HttpParam(name = "CustomerBillingDetailDTO", type = HttpParamType.COMMON, description = "CustomerBillingDetailDTO") CustomerBillingDetailDTO selectDTO,
            @HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
            @HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit,
            @NotNull @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "管理员ID") Long adminId) throws ServiceException;

    @HttpMethod(description = "添加", permission = "customerBillingDetail:customerbillingdetail:create", permissionParentName = "其他", permissionName = "customerBillingDetail")
    public CustomerBillingDetailDO create(
            @HttpParam(name = "CustomerBillingDetailDTO", type = HttpParamType.COMMON, description = "CustomerBillingDetailDTO") CustomerBillingDetailDTO insertDTO,
            @NotNull @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "管理员ID") Long adminId) throws ServiceException;

    @HttpMethod(description = "编辑", permission = "customerBillingDetail:customerbillingdetail:edit", permissionParentName = "其他", permissionName = "customerBillingDetail")
    public String edit(
            @HttpParam(name = "CustomerBillingDetailDTO", type = HttpParamType.COMMON, description = "CustomerBillingDetailDTO") CustomerBillingDetailDTO editDTO,
            @NotNull @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "管理员ID") Long adminId) throws ServiceException;

    }