package com.iotechn.unimall.app.api.sys;

import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.domain.SysDictDataDO;
import com.iotechn.unimall.data.model.Page;

import java.util.List;

/**
 * Generate Code By Unimall
 */
@HttpOpenApi(group = "dict", description = "数据字典")
public interface DictAppService {

    @HttpMethod(description = "获取数据字典")
    public List<SysDictDataDO> getDictDataList(
            @NotNull @HttpParam(name = "dictType", type = HttpParamType.COMMON, description = "dictType") String dictType,
            @HttpParam(name = "userId", type = HttpParamType.USER_ID, description = "用户Id") Long userId) throws ServiceException;
}
