package com.iotechn.unimall.data.dto;

import com.baomidou.mybatisplus.annotations.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * Generate Code By Unimall
 */
@Data
@TableName("unimall_collection_payment")
public class CollectionPaymentTiDTO extends SuperDTO {
     /* id */
//     @Excel(name = "编号")
    private Long id;
    /* 编号 */
    @Excel(name = "编号")
    private String payNo;
//    @Excel(name = "方式", readConverterExp = "1=收款,2=提款")
    /* 方式（1收2提） */
    private String businessType;
    @Excel(name = "提款人")
    /* 收提款人 */
    private String receivingWithdrawingPeople;
    @Excel(name = "提款地点")
    /* 收提款地点 */
    private String receivingWithdrawingRegion;
     /* 收提款日期 */
     @Excel(name = "提款日期")
    private String receiptPaymentDate;
     /* 金额（欧元） */
     @Excel(name = "金额（欧元）")
    private Double deductionEuro;
     /* 金额（人民币） */
     @Excel(name = "金额（人民币）")
    private Double deductionRmb;
     /* 备注1 */
     @Excel(name = "备注1")
    private String remarks;
     /* 备注2 */
     @Excel(name = "备注2")
    private String remark;
     /* 状态 */
     @Excel(name = "状态", readConverterExp = "0=正常,1=作废")
    private Integer status;
     /* 创建时间 */
    private Date gmtCreate;
     /* 更新时间 */
    private Date gmtUpdate;
     /* userId */
    private Long userId;
     /* adminId */
    private Long adminId;
     /* 公司id */
    private Long companyId;
    private String type;
    private double deductionEurotj;
    private double deductionRmbtj;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private String startDate;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private String endDate;
    private List<CollectionPaymentTiDTO> collectionPaymentDTOList;
}
