package com.iotechn.unimall.data.dto;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;

import java.awt.*;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel;
import com.iotechn.unimall.data.domain.CustomerBillingDetailDO;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * Generate Code By Unimall
 */
@Data
@TableName("unimall_customer_billing_info")
public class CustomerBillingInfoDTO extends SuperDTO {

     /* id */
    private Long id;
     /* 编号 */
     @Excel(name = "编号")
    private String payNo;
    /* 客户 */
    @Excel(name = "客户")
    private String customer;
     /* 单据类型 */
     @Excel(name = "单据类型",readConverterExp = "1=正常单据,2=结转单据")
    private String businessType;
     /* 结账日期 */
     @Excel(name = "装车日期")
    private String closingDate;
    /*应付金额 */
    @Excel(name = "应付金额")
    private Double amountIng;
     /* 已付金额 */
    private Double amountPaid;
     /* 未付金额 */
    private Double unpaidAmount;
     /* 备注1 */
     @Excel(name = "备注1")
    private String remarks;
     /* 备注2 */
     @Excel(name = "备注2")
    private String remark;
     /* 状态 */
     @Excel(name = "状态",readConverterExp = "1=未付款,2=部分付款,3=已付款")
    private Integer status;
     /* gmtCreate */
    private Date gmtCreate;
     /* gmtUpdate */
    private Date gmtUpdate;
     /* userId */
    private Long userId;
     /* adminId */
    private Long adminId;
     /* companyId */
    private Long companyId;
     /* updatePeople */
    private String updatePeople;
    private List<CustomerBillingDetailDTO> customerBillingDetailDTOS;
    private List<CustomerBillingInfoDTO> customerBillingInfoDTOS;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private String startDate;
    @JsonFormat(pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private String endDate;

    /* 柜号 */
    private String cabinetNo;
    /* 到港日期 */
    private String arrivalDate;
    /* 产品 */
    private String product;
    /* 发货公司 */
    private String sendComp;
    /* 车队 */
    private String carTeam;
    /* 送货地点 */
    private String deliveryPlace;
    /* 清关费 */
    private Double clearanceFee;
    /* 清关成本 */
    private Double clearanceCost;
    /* 卡车 */
    private Double truck;
    /* 卡车成本 */
    private Double truckCost;
    /* 其他费用 */
    private Double otherExpenses;
    /* 其他成本 */
    private Double otherCost;
}
